package com.engine.organization.mapper.sequence;


import com.engine.organization.entity.sequence.po.SequencePO;
import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @Author dxfeng
 * @description:
 * @Date 2022/5/12
 * @Version V1.0
 **/
public interface SequenceMapper {

    /**
     * 根据No查询岗位
     *
     * @param sequenceNo
     * @return
     */
    List<SequencePO> listByNo(@Param("sequenceNo") String sequenceNo);

    /**
     * 查询所有被引用的ID
     *
     * @return
     */
    List<String> listUsedId();

    /**
     * 获取岗位根据ID
     *
     * @param id
     * @return
     */
    SequencePO getSequenceByID(@Param("id") long id);

    /**
     * 根据ID查询岗位列表
     *
     * @param ids
     * @return
     */
    @MapKey("id")
    List<Map<String, Object>> listSequencesByIds(@Param("ids") Collection<Long> ids);

    /**
     * 插入岗位
     *
     * @param sequencePO
     * @return
     */
    int insertIgnoreNull(SequencePO sequencePO);

    /**
     * 修改，修改所有字段
     *
     * @param sequencePO
     * @return
     */
    int updateSequence(SequencePO sequencePO);

    /**
     * 更新禁用标记
     *
     * @param sequencePO
     * @return
     */
    int updateForbiddenTagById(SequencePO sequencePO);

    /**
     * 批量删除岗位方案
     *
     * @param ids
     */
    int deleteByIds(@Param("ids") Collection<Long> ids);

    /**
     * 根据禁用标记统计
     *
     * @param tag
     * @return
     */
    int getCountByTag(@Param("tag") int tag);

    List<SequencePO> getSequencesByIds(@Param("ids") Collection<Long> ids);

    SequencePO getSequenceBySchemeId(@Param("schemeId") Long schemeId);
}
